package es.ucm.fdi.grasia.faerie.admin.gui;

import java.awt.EventQueue;
import java.io.IOException;
import java.net.URL;

import javax.swing.DefaultListModel;
import javax.swing.ListModel;

import org.apache.felix.scr.annotations.Component;

import es.ucm.fdi.grasia.faerie.core.AbstractContextComponent;
import es.ucm.fdi.grasia.faerie.core.Entity;

/**
 * 
 * @author Chema
 */
@Component(inherit = true)
public class AdminGUIComponent extends AbstractContextComponent {

	private DefaultListModel faerieBundles = setUpFaerieComponents();

	DefaultListModel setUpFaerieComponents() {
		return new DefaultListModel();
	}

	ListModel getFaerieBundles() {
		return faerieBundles;
	}

	@Override
	public void activate() {
		super.activate();

		EventQueue.invokeLater(new Runnable() {

			@Override
			public void run() {
				new AdminGUI(AdminGUIComponent.this).setVisible(true);
			}
		});
	}

	public void installBundle(URL bundleURL) throws IOException {
		Entity bundleEntity = this.getContextBroker().installBundle(bundleURL);
		if (!faerieBundles.contains(bundleEntity))
			faerieBundles.addElement(bundleEntity);
	}

	public void uninstallBundle(Entity bundleEntity) {
		this.getContextBroker().uninstallBundle(bundleEntity);
		if (faerieBundles.contains(bundleEntity))
			faerieBundles.removeElement(bundleEntity);
	}

	public void instantiateComponent(String componentName) {
		this.getContextBroker().instantiateComponent(componentName);
	}
}
